unit mp3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, Bass;

type
  TPlayerMode = (Stop, Play, Paused);
  TForm_player = class(TForm)
    pb1: TPaintBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Button4: TButton;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ScrollBar1: TScrollBar;
    TrackBar1: TTrackBar;
    TrackBar12: TTrackBar;
    TrackBar3: TTrackBar;
    TrackBar4: TTrackBar;
    TrackBar5: TTrackBar;
    TrackBar6: TTrackBar;
    TrackBar7: TTrackBar;
    TrackBar8: TTrackBar;
    TrackBar9: TTrackBar;
    TrackBar10: TTrackBar;
    TrackBar11: TTrackBar;
    ListBox1: TListBox;
    TrackBar2: TTrackBar;
    Button5: TButton;
    OpenDialog1: TOpenDialog;
    Timer1: TTimer;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Player;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ScrollBar1Scroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form_player: TForm_player;
  i:integer; //    playlist
  filename: string;// 
  Channel    : DWORD;//
  Mode: TPlayerMode;//PlayMode
implementation
{$R *.dfm}

procedure TForm_Player.Player;
begin
//,   
if mode<>paused then begin
//       PlayList
//   ,  
if not FileExists(FileName) then begin ShowMessage('  ');exit;end;
//    
BASS_ChannelStop(Channel);BASS_StreamFree(Channel);
//      
Channel := BASS_StreamCreateFile(FALSE, PChar(FileName), 0, 0, 0 {$IFDEF UNICODE} or BASS_UNICODE {$ENDIF});
//  =0 (        ),
//     
if Channel=0 then begin ShowMessage('  ');exit;end;
end;


// BASS_ChannelPlay(Channel, False)   ,
//  ,     
if not BASS_ChannelPlay(Channel, False) then
			begin ShowMessage('  ');exit;end;

// 
    scrollbar1.Min:=0; // 
    scrollbar1.Max:=bass_ChannelGEtLength(Channel, 0)-1;// 

//     
Form_Player.Caption:=ExtractFileName(FileName);
 // PlayMode - play
 mode:=play;
end;

procedure TForm_player.ScrollBar1Scroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
//        scrollbar
 bass_ChannelSetPosition(Channel, scrollbar1.position, 0);
end;

procedure TForm_player.Timer1Timer(Sender: TObject);
var
TrackLen, TrackPos: Double;
ValPos: Double;
ValLen: Double;
begin
//  ,   Play  
if mode<>play then Exit;

//  
//       ,
if  BASS_ChannelGetPosition(channel, 0)=BASS_ChannelGetLength(channel, 0) then
   begin
//     
if i<ListBox1.Items.Count-1 then
   begin
    inc(i);
 Filename:=ListBox1.Items.Strings[i];
 ListBox1.ItemIndex:=i;
    mode:=stop;
    player;
   end
//   - 
   else exit;
   end;

//  scrollbar     
scrollbar1.Position:=bass_channelGetPosition(channel,0);

//  
//      
TrackPos:=BASS_ChannelBytes2Seconds(Channel,BASS_ChannelGetPosition(Channel,0));
//     
TrackLen:=BASS_ChannelBytes2Seconds(Channel,BASS_ChannelGetLength(Channel,0));
//   
ValPos:=TrackPos / (24 * 3600);
ValLen:=TrackLen / (24 * 3600);
//       Label1  Label2
Label1.Caption:=FormatDateTime('hh:mm:ss',ValPos);
Label2.Caption:=FormatDateTime('hh:mm:ss',ValLen);

//  
BASS_ChannelSetAttribute(Channel,BASS_ATTRIB_VOL,trackBar1.Position/10);
// 
BASS_ChannelSetAttribute(Channel,BASS_ATTRIB_PAN,Trackbar2.Position/5);

end;

procedure TForm_player.Button1Click(Sender: TObject);
begin
//      
if mode=play then exit ;
//  
player;
end;

procedure TForm_player.Button2Click(Sender: TObject);
begin
//   
if mode=play then
begin
 BASS_ChannelPause(Channel);//  - 
 mode:=paused;// playmode -> 
end;
end;

procedure TForm_player.Button3Click(Sender: TObject);
begin
//   
if mode=play then
begin
 BASS_ChannelStop(Channel);//  - 
 mode:=Stop;// playmode -> 
end;
end;

procedure TForm_player.Button4Click(Sender: TObject);
var j: integer;
begin
 OpenDialog1.Title  := 'Open Files';
 OpenDialog1.Filter := 'mp3|*.mp3'; //  
//  PlayList       
//    0 (   PlayList)
if listbox1.Count<>0 then i:=ListBox1.ItemIndex else i:=0;
//  
if not OpenDialog1.Execute then exit;
  begin
  for j:=0 to OpenDialog1.Files.Count-1 do
    begin
    // PlayList
      ListBox1.Items.Add(OpenDialog1.Files.Strings[j]);
    end;
  end;
  //      
   Filename:=ListBox1.Items.Strings[i];
  //    PlayList
   ListBox1.ItemIndex:=i;
end;


procedure TForm_player.Button5Click(Sender: TObject);
begin
// 
listbox1.Clear;
end;

procedure TForm_player.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//   
  Bass_Stop(); // 
  BASS_StreamFree(channel); //   
  Bass_Free;//   Bass
end;

procedure TForm_player.FormCreate(Sender: TObject);
begin
  // 
    trackbar1.Min:=0;
    trackbar1.Max:=10;
    trackbar1.Position:=5;
  // 
    trackbar2.Min:=-5;
    trackbar2.Max:=5;
    trackbar2.Position:=0;



  //    BASS.DLL
  if (HIWORD(BASS_GetVersion) <> BASSVERSION)  then
	begin
		MessageBox(0,'   BASS.DLL',nil,MB_ICONERROR);
		Halt;
	end;

	//   -  , 44100hz, stereo, 16 bits
	if not BASS_Init(-1, 44100, 0, Handle, nil) then
    begin
      MessageBox(0,'  ',nil,MB_ICONERROR);
		  Halt;
    end;
end;

procedure TForm_player.ListBox1DblClick(Sender: TObject);
begin
 i:=ListBox1.Itemindex;
 Filename:=ListBox1.Items.Strings[i];
 mode:=stop;
 player;
end;

end.
